require 'minitest/autorun'
require_relative '../lib/array_processor'


class ArrayProcessorTest < Minitest::Test
    def setup
        @processor = ArrayProcessor.new([1, 2, 3, 4, 5, 6, 7, 8, 9])
    end

    def test_chunk
        result = @processor.chunk { |x| x.even? }
        assert_equal [[1], [2], [3], [4], [5], [6], [7], [8], [9]], result
    end

    def test_include
        assert_equal true, @processor.include?(5)
        assert_equal false, @processor.include?(10)
    end

    def test_reduce
        assert_equal 45, @processor.reduce(0) { |acc, x| acc + x }
        assert_equal 120, @processor.reduce(1) { |acc, x| acc * x }
    end

    def test_member
        assert_equal true, @processor.member?(5)
        assert_equal false, @processor.member?(10)
    end

    def test_filter
        result = @processor.filter { |x| x.odd? }
        assert_equal [1, 3, 5, 7, 9], result
    end
end
